<template>

  <basic-container>

    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">

      <template slot="status" slot-scope="scope" >
        <el-tag v-if="scope.row.status === 1" type="success">{{scope.row.$status}}</el-tag>
        <el-tag v-if="scope.row.status === 0" type="danger">{{scope.row.$status}}</el-tag>
      </template>

      <template slot="menu" slot-scope="scope">
        <el-button v-if="scope.row.status == 0"
                   type="text"
                   size="small"
                   @click="modifyState(scope.row, 1)"
        >启用</el-button>
        <el-button v-if="scope.row.status == 1"
                   type="text"
                   size="small"
                   @click="modifyState(scope.row, 0)"
        >禁用
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/groupon/selftake";
  import {mapGetters} from "vuex";
  import {getUsualLogs} from "../../api/logs";

  export default {
    data() {
      return {
        lo: 0.0,
        la: 0.0,
        address: '',
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          delBtn: false,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "名称",
              prop: "name",
              search: true,
              labelWidth: 120,
              rules: [{
                required: true,
                message: "请输入自提点名字",
                trigger: "blur"
              }]
            },
            {
              label: "地址",
              prop: "addressTemp",
              labelWidth: 120,
              type: 'map',
              hide: true,
              rules: [{
                required: true,
                message: "请输入自提点地址",
                trigger: "blur"
              }],
            },
            {
              label: "地址",
              prop: "address",
              addDisplay: false,
              editDisplay: false,
              labelWidth: 120,
            },
            {
              label: "营业开始时间",
              prop: "busStartTime",
              valueFormat: 'HH:mm:ss',
              labelWidth: 120,
              type: "time",
              pickerOptions:{
                start: '08:00',
                step: '00:15',
                end: '22:00'
              },
              rules: [{
                required: true,
                message: "请输入营业开始时间",
                trigger: "blur"
              }]
            },
            {
              label: "营业结束时间",
              prop: "busEndTime",
              valueFormat: 'HH:mm:ss',
              labelWidth: 120,
              type: "time",
              pickerOptions:{
                start: '08:00',
                step: '00:15',
                end: '22:00'
              },
              rules: [{
                required: true,
                message: "请输入营业结束时间",
                trigger: "blur"
              }]
            },
            {
              label: "状态",
              prop: "status",
              labelWidth: 120,
              rules: [{
                required: true,
                message: "请输入状态",
                trigger: "blur"
              }],
              search: true,
              slot:true,
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/getEnumDict?enumName=StatusEnum",
              props: {
                label: "name",
                value: "value"
              },
              dataType: "number",
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.selftake_add, false),
          viewBtn: this.vaildData(this.permission.selftake_view, false),
          delBtn: this.vaildData(this.permission.selftake_delete, false),
          editBtn: this.vaildData(this.permission.selftake_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        row.longitude = row.addressTemp[0];
        row.latitude = row.addressTemp[1];
        row.address = row.addressTemp[2];
        console.log(row)
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        row.longitude = row.addressTemp[0];
        row.latitude = row.addressTemp[1];
        row.address = row.addressTemp[2];
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      },
      modifyState(row, status) {
        let title = status === 0 ? '确定禁用？' : '确定启用？';
        this.$confirm(title, {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          const loading = this.$loading({
            lock: true,
            text: '修改中，请稍等...',
            spinner: 'el-icon-loading',
            background: 'rgba(0, 0, 0, 0.7)'
          });
          row.status = status;
          update(row).then(() => {
            loading.close();
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          }, error => {
            loading.close();
            console.log(error);
          });
        })
      },
    }
  };
</script>

<style>
</style>
